var baseURL = "";
var rotateDegree = 0;
var isRecordingVideo = false;
var isPaused = false;
var isDisconnected = false;
var supportedSize = new Array();
var currentSize = new CameraSize();
var isChrome = false;
var isFirefox = false;
var isIOS = false;
var isSafari = false;
var isIE = false;
var snackbarRecord;
var snackbarPause;
var isNightVision = false;
var password;
var passwordOK = '';
var isTabHidden = false;
var updatingImage = false;
var imgError = false;
var batteryString = "";
var lastHourClock = new Date().toLocaleTimeString();

// ========= PIP MODE ========= //
var counterImagePiP = 0;
var sourceCanvas;
var ctxCanvas;
var streamCanvas;
var canDownloadImageCanvas = false;
// ========= PIP MODE ========= //

function CameraSize() {
    this.width = 0;
    this.height = 0;
}

$(document).ready(function() {
    checkBrowser();

    baseURL = $(location).attr('href');

    $("#btn_flash").bind("click", flash);
    $("#btn_rotate").bind("click", rotate);
    $("#btn_switch").bind("click", switchCamera);
    $("#btn_save_photo").bind("click", savePhoto);
    $("#btn_save_video").bind("click", saveVideo);
    $("#btn_listen").bind("click", listen);
    $("#btn_music").bind("click", music);
    $("#btn_pause_resume").bind("click", pauseOrResume);
    $("#btn_powerOff").bind("click", powerOff);
    $("#btn_reconnect").bind("click", reconnect);
    $("#btn_night_vision").bind("click", nightVision);
    $("#btn_pip").bind("click", startPictureInPicture);

    if (isSafari || isIOS) {
        $("#div_btn_listen").hide();
    }

    showHiddeButtonPiP();

    $("#audioPlayer").on('pause', function() {
        stopAudio();
    });

    $("#audioPlayer").on('ended', function() {
        stopAudio();
    });

    $("#myZoom").on("keyup", function() {
        var zoom = $(this).val();
        sendZoom(zoom);
    });

    $("#myZoom").on('slidestop', function(event) {
        var zoom = $(this).val();
        sendZoom(zoom);
    });

    checkLanguage();
    themeSelector();

    queryPasswordEnabled();

    var x = getCookie('theme');
    if (x == 'b') {
        $("#b").trigger("click");
        $("#label_" + x).addClass('ui-btn-active');
    } else {
        $("#a").trigger("click");
        $("#label_" + x).addClass('ui-btn-active');

        //Automatic dark mode
        try {
            if (window.matchMedia && window.matchMedia('(prefers-color-scheme: dark)').matches) {
                changeTheme('b');
                $("#label_a").removeClass('ui-btn-active');
                $("#label_b").addClass('ui-btn-active');
            }
        } catch (error) {}
    }
});

function sendZoom(zoom) {
    if (zoom != "" && Number(zoom) >= 0 && Number(zoom) <= 100) {
        showLoader();

        var zoomRequest = {
            percentage: Number(zoom)
        };

        $.ajax({
            headers: {
                'Password': passwordOK
            },
            type: "POST",
            url: baseURL + "api/v1/camera/zoom",
            dataType: "json",
            data: JSON.stringify(zoomRequest),
            error: hideLoaderError,
            success: hideLoader,
            cache: false,
            timeout: 15000
        });
    }
}

var onQueryDone = function(ret) {
    hideLoader();

    $("#resolution-choice").empty();
    var resList = ret.resolutions;

    if (resList.length == 0) {
        return;
    }

    supportedSize = new Array();

    for (var i = 0; i < resList.length; i++) {
        var res = resList[i].split("x");
        var newRes = new CameraSize();
        newRes.width = res[0];
        newRes.height = res[1];
        supportedSize.push(newRes);
        var newOption = "<option value='" + (i) + "'>" + resList[i] + "</option>";
        $("#resolution-choice").append(newOption);
    }
    $("#resolution-choice").selectmenu('refresh');
    $("#resolution-choice").bind("change", doChangeRes);

    var targetIndex = $("#resolution-choice").val();
    currentSize = supportedSize[targetIndex];

    doChangeRes();

    refreshLive();
};

var refreshLive = function() {
    refreshLiveInternal();
};

function refreshLiveInternal() {
    if (!isTabHidden && !isPaused) {
        $("img#camera").unbind();
        $("img#camera").attr("src", baseURL + "api-stream/v1/video" + addPasswordFirstParam() + addRandomNumber());
        $("img#camera").width(0);
        $("img#camera").width(1280);

        $("img#camera").load(function() {
            imgError = false;

            if (!isPaused) {
                $("#error_camera").hide();
                $("#error_camera2").hide();
                $("img#error_image").hide();
                $("#div_btn_reconnect").hide();

                $("img#camera").show();

                isDisconnected = false;
            } else {
                $("#error_camera").hide();
                $("#error_camera2").hide();
                $("img#error_image").hide();
                $("#div_btn_reconnect").hide();

                $("img#camera").hide();
            }
        });

        $("img#camera").error(function() {
            $("img#camera").hide();
            imgError = true;
        });
    }
}

var refreshLiveWhenError = function() {
    if (!isTabHidden) {
        $("#error_camera").show();
        $("#error_camera2").show();
        $("img#error_image").show();
        $("#div_btn_reconnect").show();
        $("img#camera").hide();
        $("#time").hide();

        if (!isPaused) {
            $("img#camera").hide();
            imgError = true;
            refreshLiveInternal();

            isDisconnected = true;
        }
    }
};

var flash = function() {
    showLoader();

    $.ajax({
        headers: {
            'Password': passwordOK
        },
        type: "GET",
        url: baseURL + "api/v1/camera/flash",
        cache: false,
        error: hideLoaderError,
        success: hideLoader,
        timeout: 15000
    });
};

var switchCamera = function() {
    showLoader();

    $.ajax({
        headers: {
            'Password': passwordOK
        },
        type: "GET",
        url: baseURL + "api/v1/camera/switch",
        dataType: "json",
        cache: false,
        error: hideLoaderError,
        success: onQueryDone,
        timeout: 15000
    });

    $("#myZoom").val(1);
    $("#myZoom").slider("refresh");
};

var batteryQuery = function() {
    $.ajax({
        headers: {
            'Password': passwordOK
        },
        type: "GET",
        url: baseURL + "api/v1/battery",
        cache: false,
        error: onBatteryQueryErrorRetry,
        success: onBatteryQueryDone,
        timeout: 15000
    });
};

var onBatteryQueryErrorRetry = function() {
    setTimeout(batteryQuery, 10000);
};

var onSetupOK = function() {
    var targetIndex = $("#resolution-choice").val();
    currentSize = supportedSize[targetIndex];
    hideLoader();
};

var doChangeRes = function() {
    var targetIndex = $("#resolution-choice").val();
    var wid = supportedSize[targetIndex].width;
    var hei = supportedSize[targetIndex].height;

    var cameraResolutionChangeRequest = {
        width: wid,
        height: hei
    };

    rotateDegree = -90;
    rotate();

    showLoader();

    $.ajax({
        headers: {
            'Password': passwordOK
        },
        type: "POST",
        url: baseURL + "api/v1/camera/change-resolution",
        dataType: "json",
        data: JSON.stringify(cameraResolutionChangeRequest),
        cache: false,
        error: hideLoaderError,
        success: onSetupOK,
        timeout: 15000
    });
};

function rotate() {
    rotateDegree = (rotateDegree + 90) % 360;
    // For webkit browsers: e.g. Chrome
    $('img#camera').css({
        WebkitTransform: 'rotate(' + rotateDegree + 'deg)'
    });
    // For Mozilla browser: e.g. Firefox
    $('img#camera').css({
        '-moz-transform': 'rotate(' + rotateDegree + 'deg)'
    });
    //IE
    $('img#camera').css({
        '-ms-transform': 'rotate(' + rotateDegree + 'deg)'
    });
    //Opera
    $('img#camera').css({
        '-o-transform': 'rotate(' + rotateDegree + 'deg)'
    });
}

function sendOnline() {
    sendOnlineOnly();

    setTimeout(sendOnline, 60000);
}

function sendOnlineOnly() {
    var clientOnlineRequest = {
        ip: "1.1.1.1",
        deviceName: "BabyCam Web"
    };

    $.ajax({
        headers: {
            'Password': passwordOK
        },
        type: "POST",
        url: baseURL + "api/v1/client/online",
        dataType: "json",
        data: JSON.stringify(clientOnlineRequest),
        cache: false,
        timeout: 15000
    });
}

function savePhoto() {
    window.location.href = "api-stream/v1/photo?quality=80&download=true" + addPasswordParam();
}

function saveVideo() {
    var recordVideoRequest;
    if (!isRecordingVideo) {
        isRecordingVideo = true;

        recordVideoRequest = {
            command: "START"
        };
    } else {
        isRecordingVideo = false;

        recordVideoRequest = {
            command: "STOP_AND_DOWNLOAD"
        };
    }

    showLoader();

    $.ajax({
        headers: {
            'Password': passwordOK
        },
        type: "POST",
        url: baseURL + "api/v1/camera/record-video",
        dataType: "json",
        data: JSON.stringify(recordVideoRequest),
        timeout: 15000,
        cache: false,
        error: hideLoaderError,
        success: function(data) {
            if (data.status == "OK_STOP_AND_DOWNLOAD") {
                isRecordingVideo = false;

                hideLoader();

                if (snackbarRecord != null) {
                    snackbarRecord.hide();
                }

                window.location.href = "api-stream/v1/download-video" + addPasswordFirstParam();
            } else if (data.status == "REPEAT") {
                isRecordingVideo = false;

                setTimeout(saveVideo, 10000);
            } else if (data.status == "OK_START") {
                isRecordingVideo = true;

                hideLoader();

                var options = {
                    content: data.message, // text of the snackbar
                    style: "toast", // add a custom class to your snackbar
                    timeout: 0 // time in milliseconds after the snackbar autohides, 0 is disabled
                }

                snackbarRecord = $.snackbar(options);
            } else if (data.status == "KO") {
                isRecordingVideo = false;

                hideLoader();

                var options = {
                    content: data.message, // text of the snackbar
                    style: "toast", // add a custom class to your snackbar
                    timeout: 5000 // time in milliseconds after the snackbar autohides, 0 is disabled
                }

                $.snackbar(options);
            } else {
                hideLoaderError();
            }
        }
    });
}

function nightVision() {
    if (!isNightVision) {
        $("#camera").addClass('night-vision');
        isNightVision = true;
    } else {
        $("#camera").removeClass('night-vision');
        isNightVision = false;
    }
}

function music() {
    showLoader();

    $.ajax({
        headers: {
            'Password': passwordOK
        },
        type: "GET",
        url: baseURL + "api/v1/lullaby/start-stop",
        dataType: "json",
        timeout: 15000,
        cache: false,
        error: hideLoaderError,
        success: function(data) {
            hideLoader();

            if (data.status == "PLAY") {
                var options = {
                    content: "🎶💤 ▶️", // text of the snackbar
                    style: "toast", // add a custom class to your snackbar
                    timeout: 5000 // time in milliseconds after the snackbar autohides, 0 is disabled
                }

                $.snackbar(options);
            } else if (data.status == "STOP") {
                var options = {
                    content: "🎶💤 ⏹️", // text of the snackbar
                    style: "toast", // add a custom class to your snackbar
                    timeout: 5000 // time in milliseconds after the snackbar autohides, 0 is disabled
                }

                $.snackbar(options);
            } else {
                hideLoaderError();
            }
        }
    });
}


var cameraStatusQuery = function() {
    $.ajax({
        headers: {
            'Password': passwordOK
        },
        type: "GET",
        url: baseURL + "cgi/getUpdatingImage",
        cache: false,
        error: onCameraStatusQueryErrorRetry,
        success: onCameraStatusQueryDone,
        timeout: 10000
    });
};

var onCameraStatusQueryErrorRetry = function() {
    imgError = true;
    setTimeout(refreshLiveWhenError, 500);
    setTimeout(cameraStatusQuery, 10000);
};

var onCameraStatusQueryDone = function(ret) {
    $("#error_camera").hide();
    $("#error_camera2").hide();
    $("img#error_image").hide();
    $("#div_btn_reconnect").hide();

    if (ret == '') {
        if (!isPaused) {
            cameraPauseOK();
            sendOnlineOnly();
        }
    } else {
        if (isPaused && (ret == 'OK' || ret == 'KO')) {
            cameraResumeOK();
            sendOnlineOnly();
        }

        if (imgError == true && !isPaused) {
            $("img#camera").attr("src", "");
            refreshLiveWhenError();
        }

        if (ret == 'OK') {
            updatingImage = true;
        } else if (ret == 'KO') {
            updatingImage = false
        }
    }

    setTimeout(cameraStatusQuery, 5000);
};

function pauseOrResume() {
    showLoader();

    if (!isPaused) {
        $.ajax({
            headers: {
                'Password': passwordOK
            },
            type: "GET",
            url: baseURL + "api/v1/camera/off",
            timeout: 15000,
            cache: false,
            error: hideLoaderError,
            success: function(data) {
                cameraPauseOK();
                sendOnlineOnly();

                if (document.pictureInPictureElement) {
                    document.exitPictureInPicture();
                    return;
                }
            }
        });
    } else {
        $.ajax({
            headers: {
                'Password': passwordOK
            },
            type: "GET",
            url: baseURL + "api/v1/camera/on",
            timeout: 15000,
            cache: false,
            error: hideLoaderError,
            success: function(data) {
                cameraResumeOK();
                sendOnlineOnly();
            }
        });
    }
}

function cameraPauseOK() {
    hideLoader();
    var options = {
        content: "📷⏸", // text of the snackbar
        style: "toast", // add a custom class to your snackbar
        timeout: 5000 // time in milliseconds after the snackbar autohides, 0 is disabled
    }

    snackbarPause = $.snackbar(options);

    if (snackbarRecord != null) {
        snackbarRecord.hide();
    }

    $("#error_camera").hide();
    $("#error_camera2").hide();
    $("img#error_image").hide();

    $("img#camera").hide();
    $("#time").hide();

    $("img#camera").unbind();

    //Botones
    $("#div_btn_flash").hide();
    $("#div_btn_switch").hide();
    $("#div_btn_save_photo").hide();
    $("#div_btn_save_video").hide();
    $("#div_btn_rotate").hide();
    $("#div_zoom").hide();
    $("#div_btn_night_vision").hide();
    $("#resolution").hide();
    $("#resolution-choice-button").hide();

    isPaused = true;

    showHiddeButtonPiP();
}

function cameraResumeOK() {
    hideLoader();

    var options = {
        content: "📷▶️", // text of the snackbar
        style: "toast", // add a custom class to your snackbar
        timeout: 5000 // time in milliseconds after the snackbar autohides, 0 is disabled
    }

    $.snackbar(options);

    if (snackbarPause != null) {
        snackbarPause.hide();
    }

    isPaused = false;

    refreshLive();

    $("#div_btn_flash").show();
    $("#div_btn_switch").show();
    $("#div_btn_save_photo").show();
    $("#div_btn_save_video").show();
    $("#div_btn_rotate").show();
    $("#div_zoom").show();
    $("#div_btn_night_vision").show();
    $("#resolution").show();
    $("#resolution-choice-button").show();

    showHiddeButtonPiP();
}

function powerOff() {
    showLoader();

    $.ajax({
        headers: {
            'Password': passwordOK
        },
        type: "GET",
        url: baseURL + "api/v1/camera/power-off",
        timeout: 15000,
        cache: false,
        error: hideLoaderError,
        success: function(data) {
            hideLoader();

            isDisconnected = true;

            $("#error_camera").show();
            $("#error_camera2").show();
            $("img#error_image").show();
            $("#div_btn_reconnect").show();

            $("img#camera").hide();
            $("#time").hide();

            var options = {
                content: "📷➡️📴", // text of the snackbar
                style: "toast", // add a custom class to your snackbar
                timeout: 5000 // time in milliseconds after the snackbar autohides, 0 is disabled
            }

            $.snackbar(options);

            if (snackbarPause != null) {
                snackbarPause.hide();
            }

            $("img#camera").unbind();

            if (document.pictureInPictureElement) {
                document.exitPictureInPicture();
                return;
            }
        }
    });
}

function reconnect() {
    showLoader();

    $.ajax({
        type: "GET",
        url: baseURL.replace("8080", "8081") + "cgi/initServer" + addPasswordFirstParam(),
        timeout: 15000,
        cache: false,
        error: hideLoaderError,
        success: function(data) {
            isDisconnected = false;
            isPaused = false;
            setTimeout(hideLoader, 5000);
            setTimeout(refreshLive, 5000);

            $("#div_btn_flash").show();
            $("#div_btn_switch").show();
            $("#div_btn_save_photo").show();
            $("#div_btn_save_video").show();
            $("#div_btn_rotate").show();
            $("#div_zoom").show();
            $("#div_btn_night_vision").show();
            $("#resolution").show();
            $("#resolution-choice-button").show();
        }
    });
}

var isListening = "NO"

function listen() {
    if (isListening.startsWith("NO")) {
        playAudio();
    } else {
        stopAudio();
    }
}

function playAudio() {
    isListening = "YES"

    var audioElement = document.querySelector("audio");

    audioElement.addEventListener('error', function failed(e) {
        if (isListening == "YES") {
            hideLoaderError();
            isListening = "NO";
            if (!isChrome && !isFirefox) {
                var options = {
                    content: "It only works with Google Chrome or Mozilla Firefox", // text of the snackbar
                    style: "toast", // add a custom class to your snackbar
                    timeout: 5000 // time in milliseconds after the snackbar autohides, 0 is disabled
                }

                $.snackbar(options);
            }
        }
    }, true);

    audioElement.src = "/api-stream/v1/audio" + addPasswordFirstParam()
    audioElement.controls = true;

    audioElement.load();
    audioElement.play();
}

function stopAudio() {
    isListening = "NO"

    var audioElement = document.querySelector("audio");
    audioElement.src = "about:blank"

    audioElement.pause();
    // settimeout, otherwise pause event is not raised normally
    setTimeout(function() {
        audioElement.load(); // This stops the stream from downloading
    });

    audioElement.controls = false;
}

var showLoader = function() {
    $("body").addClass('ui-disabled');

    var $this = $(this),
        theme = $this.jqmData("theme") || $.mobile.loader.prototype.options.theme,
        msgText = $this.jqmData("msgtext") || $.mobile.loader.prototype.options.text,
        textVisible = $this.jqmData("textvisible") || $.mobile.loader.prototype.options.textVisible,
        textonly = !!$this.jqmData("textonly");
    html = $this.jqmData("html") || "";
    $.mobile.loading("show", {
        text: msgText,
        textVisible: textVisible,
        theme: theme,
        textonly: textonly,
        html: html
    });
}

var hideLoader = function() {
    $.mobile.loading("hide");
    $("body").removeClass('ui-disabled');
}

var hideLoaderError = function() {
    $.mobile.loading("hide");
    $("body").removeClass('ui-disabled');

    var options = {
        content: "😞️", // text of the snackbar
        style: "toast", // add a custom class to your snackbar
        timeout: 5000 // time in milliseconds after the snackbar autohides, 0 is disabled
    }

    $.snackbar(options);
}

function themeSelector() {
    $("#theme-selector input").on("change", function(event) {
        var themeClass = $("#theme-selector input:checked").attr("id");
        changeTheme(themeClass);
        setCookie('theme', themeClass, 365);
    });
}

function changeTheme(themeClass) {
    $("#page_main").removeClass("ui-page-theme-a ui-page-theme-b").addClass("ui-page-theme-" + themeClass);
    if (themeClass == 'b') {
        $("body").css('background-color', '#2a2a2a');
    } else {
        $("body").css('background-color', '#fff');
    }
}

function setCookie(name, value, days) {
    var expires = '',
        date = new Date();
    if (days) {
        date.setTime(date.getTime() + (days * 24 * 60 * 60 * 1000));
        expires = '; expires=' + date.toGMTString();
    }
    document.cookie = name + '=' + value + expires + '; path=/';
}

function getCookie(name) {
    var nameEQ = name + '=',
        allCookies = document.cookie.split(';'),
        i,
        cookie;
    for (i = 0; i < allCookies.length; i += 1) {
        cookie = allCookies[i];
        while (cookie.charAt(0) === ' ') {
            cookie = cookie.substring(1, cookie.length);
        }
        if (cookie.indexOf(nameEQ) === 0) {
            return cookie.substring(nameEQ.length, cookie.length);
        }
    }
    return null;
}

function queryPasswordEnabled() {
    showLoader();

    $.ajax({
        type: "GET",
        url: baseURL + "api/v1/password/enabled",
        dataType: "json",
        timeout: 15000,
        cache: false,
        error: function(data) {
            hideLoaderError();

            $.ajax({
                headers: {
                    'Password': passwordOK
                },
                type: "GET",
                url: baseURL + "api/v1/camera/resolutions",
                dataType: "json",
                cache: false,
                error: hideLoaderError,
                success: onQueryDone,
                timeout: 15000
            });
        },
        success: function(data) {
            hideLoader();

            if (data.status == "YES") {
                var passUser = prompt("🔐", "");
                if (passUser == null) {
                    window.location = 'https://www.google.com';
                } else {
                    password = passUser;
                    checkPassword();
                }
            } else {
                hideLoader();

                init();

                $.ajax({
                    headers: {
                        'Password': passwordOK
                    },
                    type: "GET",
                    url: baseURL + "api/v1/camera/resolutions",
                    dataType: "json",
                    cache: false,
                    error: hideLoaderError,
                    success: onQueryDone,
                    timeout: 15000
                });
            }
        }
    });
}

function checkPassword() {
    showLoader();

    //https://stackoverflow.com/questions/30106476/using-javascripts-atob-to-decode-base64-doesnt-properly-decode-utf-8-strings/30106551#30106551
    var passwordRequest = {
        password: window.btoa(unescape(encodeURIComponent(password)))
    };

    $.ajax({
        type: "POST",
        url: baseURL + "api/v1/password/check",
        timeout: 15000,
        dataType: "json",
        data: JSON.stringify(passwordRequest),
        cache: false,
        error: function(data) {
            hideLoaderError();
            checkPassword();
        },
        success: function(data) {
            hideLoader();

            if (data.status == "OK") {
                passwordOK = window.btoa(unescape(encodeURIComponent(password)));

                init();

                $.ajax({
                    headers: {
                        'Password': passwordOK
                    },
                    type: "GET",
                    url: baseURL + "api/v1/camera/resolutions",
                    dataType: "json",
                    cache: false,
                    error: hideLoaderError,
                    success: onQueryDone,
                    timeout: 15000
                });
            } else {
                hideLoaderError();
                queryPasswordEnabled();
            }
        }
    });
}

var sensorsQuery = function() {
    $.ajax({
        headers: {
            'Password': passwordOK
        },
        type: "GET",
        url: baseURL + "cgi/sensors",
        cache: false,
        error: onSensorsQueryErrorRetry,
        success: onSensorsQueryDone,
        timeout: 15000
    });
};

var onSensorsQueryErrorRetry = function() {
    setTimeout(sensorsQuery, 60000);
};

var onSensorsQueryDone = function(ret) {
    if (ret != '') {
        $("#sensors").html(ret);
        setTimeout(sensorsQuery, 60000);
    }
};

function updateClock() {
    if (isPaused || isDisconnected == 1) {
        $("#time").hide();
        $("#batteryInfo").show();
    } else {
        if (updatingImage) {
            lastHourClock = new Date().toLocaleTimeString();
        }

        $("#time").html(lastHourClock + "<br>" + batteryString);
        $("#time").show();
        $("#batteryInfo").hide();
    }

    setTimeout(updateClock, 1000);
}

function addPasswordParam() {
    if (passwordOK != '') {
        return "&password=" + passwordOK;
    } else {
        return "";
    }
}

function addPasswordFirstParam() {
    if (passwordOK != '') {
        return "?password=" + passwordOK;
    } else {
        return "";
    }
}

function addRandomNumber() {
    if (passwordOK != '') {
        return "&random=" + Math.random();
    } else {
        return "?random=" + Math.random();
    }
}

function init() {
    setTimeout(batteryQuery, 1000);
    setTimeout(cameraStatusQuery, 1000);
    setTimeout(sensorsQuery, 1000);
    sendOnline();
    updateClock();
}

// ========= PIP MODE ========= //
function startPictureInPicture() {
    if (document.pictureInPictureElement) {
        document.exitPictureInPicture();
        return;
    }

    canDownloadImageCanvas = true;

    sourceCanvas = document.createElement('canvas');
    ctxCanvas = sourceCanvas.getContext('2d');
    streamCanvas = sourceCanvas.captureStream();
    videoPiP.srcObject = streamCanvas;

    downloadImageAndDrawCanvasPictureInPicture();

    videoPiP.onloadeddata = function() {
        videoPiP.requestPictureInPicture();
    };

    videoPiP.addEventListener("leavepictureinpicture", stopPictureInPicture, false);
}

function downloadImageAndDrawCanvasPictureInPicture() {
    const img = new Image();
    //img.crossOrigin = 'anonymous'; // add this to request the image as cross-origin allowed
    img.src = baseURL + "api-stream/v1/photo?quality=25&id=" + counterImagePiP + addPasswordParam();
    img.onload = function() {
        if (canDownloadImageCanvas) {
            counterImagePiP++;

            sourceCanvas.height = img.naturalHeight;
            sourceCanvas.width = img.naturalWidth;

            ctxCanvas.drawImage(img, 0, 0, img.naturalWidth, img.naturalHeight, 0, 0, img.naturalWidth, img.naturalHeight);

            if (img.naturalWidth >= 1280) {
                ctxCanvas.globalAlpha = 0.4;
                ctxCanvas.fillStyle = "white";
                ctxCanvas.fillRect(0, 0, 320, 110);

                ctxCanvas.globalAlpha = 1;
                ctxCanvas.fillStyle = "black";
                ctxCanvas.font = "55px verdana";
                ctxCanvas.fillText(new Date().toLocaleTimeString(), 30, 80);
            } else if (img.naturalWidth >= 800) {
                ctxCanvas.globalAlpha = 0.4;
                ctxCanvas.fillStyle = "white";
                ctxCanvas.fillRect(0, 0, 250, 70);

                ctxCanvas.globalAlpha = 1;
                ctxCanvas.fillStyle = "black";
                ctxCanvas.font = "40px verdana";
                ctxCanvas.fillText(new Date().toLocaleTimeString(), 25, 50);
            } else if (img.naturalWidth >= 640) {
                ctxCanvas.globalAlpha = 0.4;
                ctxCanvas.fillStyle = "white";
                ctxCanvas.fillRect(0, 0, 190, 60);

                ctxCanvas.globalAlpha = 1;
                ctxCanvas.fillStyle = "black";
                ctxCanvas.font = "30px verdana";
                ctxCanvas.fillText(new Date().toLocaleTimeString(), 20, 40);
            } else {
                ctxCanvas.globalAlpha = 0.4;
                ctxCanvas.fillStyle = "white";
                ctxCanvas.fillRect(0, 0, 95, 30);

                ctxCanvas.globalAlpha = 1;
                ctxCanvas.fillStyle = "black";
                ctxCanvas.font = "15px verdana";
                ctxCanvas.fillText(new Date().toLocaleTimeString(), 10, 20);
            }

            setTimeout(downloadImageAndDrawCanvasPictureInPicture, 100);
        }
    }

    img.onerror = function() {
        setTimeout(downloadImageAndDrawCanvasPictureInPicture, 5000);
    }
}

function stopPictureInPicture() {
    canDownloadImageCanvas = false;
}

function showHiddeButtonPiP() {
    if (isChrome && document.pictureInPictureEnabled) {
        if (!isPaused) {
            $("#div_btn_pip").show();
        } else {
            $("#div_btn_pip").hide();
            if (document.pictureInPictureElement) {
                document.exitPictureInPicture();
                return;
            }
        }
    } else {
        $("#div_btn_pip").hide();
    }
}


var onBatteryQueryDone = function(ret) {
    if (ret.includes("Not charging")) {
        batteryString = "&nbsp;" + ret.replace("Not charging", "🔋&nbsp;&nbsp;");
    } else if (ret.includes("Charging")) {
        batteryString = "&nbsp;" + ret.replace("Charging", "🔋🔌&nbsp;");
    }

    $("#batteryInfo").html(batteryString);

    setTimeout(batteryQuery, 30000);
};

function checkBrowser() {
    try {
        isChrome = navigator.userAgent.indexOf("Chrome") != -1;
        isFirefox = navigator.userAgent.indexOf("Firefox") != -1;
        isIOS = /iPad|iPhone|iPod/.test(navigator.platform) || (navigator.platform === 'MacIntel' && navigator.maxTouchPoints > 1)
        isSafari = /^((?!chrome|android).)*safari/i.test(navigator.userAgent);
        isIE = /MSIE|Trident/.test(window.navigator.userAgent);

        if (!String.prototype.startsWith) {
            String.prototype.startsWith = function(searchString, position) {
                position = position || 0;
                return this.indexOf(searchString, position) === position;
            };
        }

        if (!String.prototype.includes) { //To check browser supports or not
            String.prototype.includes = function(str) { //If not supported, then define the method
                return this.indexOf(str) !== -1;
            }
        }

        if (isIE) {
            var lang = window.navigator.language;
            if (lang.startsWith("es")) {
                alert("Internet Explorer no es compatible. Por favor, usa Google Chrome o Firefox.");
            } else if (lang.startsWith("pt")) {
                alert("O Internet Explorer não é compatível. Use o Google Chrome ou Firefox.");
            } else if (lang.startsWith("pl")) {
                alert("Internet Explorer nie jest obsługiwany. Użyj przeglądarki Google Chrome lub Firefox.");
            } else if (lang.startsWith("ru")) {
                alert("Internet Explorer nu este acceptat. Vă rugăm să utilizați Google Chrome sau Firefox.");
            } else if (lang.startsWith("de")) {
                alert("Internet Explorer wird nicht unterstützt. Bitte verwenden Sie Google Chrome oder Firefox.");
            } else if (lang.startsWith("ar")) {
                alert("Internet Explorer غير مدعوم. الرجاء استخدام Google Chrome أو Firefox.");
            } else if (lang.startsWith("tr")) {
                alert("İnternet gezgini desteklenmiyor. Lütfen Google Chrome veya Firefox kullanın.");
            } else if (lang.startsWith("ro")) {
                alert("Internet Explorer nu este acceptat. Vă rugăm să utilizați Google Chrome sau Firefox.");
            } else if (lang.startsWith("fr")) {
                alert("Internet Explorer n'est pas pris en charge. Veuillez utiliser Google Chrome ou Firefox.");
            } else if (lang.startsWith("it")) {
                alert("Internet Explorer non è supportato. Si prega di utilizzare Google Chrome o Firefox.");
            } else if (lang.startsWith("cs")) {
                alert("Internet Explorer není podporován. Použijte prosím Google Chrome nebo Firefox.");
            } else {
                alert("Internet Explorer is not supported. Please use Google Chrome or Firefox.");
            }
        }

        document.addEventListener('visibilitychange', function() {
            if (document.hidden) {
                isTabHidden = true;
                $("img#camera").unbind();
                $("img#camera").attr("src", "about:blank");
                setTimeout(sendOnlineOnly, 2000);
            } else {
                isTabHidden = false;

                if (!isPaused) {
                    refreshLiveInternal();
                }
            }
        }, false);
    } catch (error) {

    }
}